import 'dart:async';

class DemonPress {
  /// 函数防抖 debounce(() {})
  ///
  /// [func]: 要执行的方法
  /// [delay]: 要迟延的时长
  void Function() debounce(
    Function func, [
    Duration delay = const Duration(milliseconds: 500),
  ]) {
    Timer? timer;
    target() {
      timer?.cancel();
      timer = Timer(delay, () {
        func.call();
      });
    }

    return target;
  }

  /// 节流  throttle(() {})
  ///
  /// [func]: 要执行的方法
  /// [delay]: 要迟延的时长
  Function throttle(
    Function func, [
    Duration delay = const Duration(milliseconds: 500),
  ]) {
    Timer? timer;
    return () {
      if (timer != null) return;
      timer = Timer(delay, () {
        func.call();
      });
    };
  }
}
